from django.urls import path

from service_catalog.api.instance_api_views import InstanceList, InstanceDetails
from service_catalog.api.admin.job_template_api_views import JobTemplateDetails, JobTemplateList
from service_catalog.api.admin.tower_server_api_views import TowerServerList, TowerServerDetails
from service_catalog.api.operation_api_views import OperationListCreate, OperationDetails, InstanceOperationList
from service_catalog.api.request_api_views import RequestList, RequestDetails, ServiceRequestCreate, \
    OperationRequestCreate
from service_catalog.api.service_api_views import ServiceListCreate, ServiceDetails
from .admin.job_template_sync import JobTemplateSync

urlpatterns = [
    # admin urls
    path('instance/', InstanceList.as_view(), name='api_instance_list'),
    path('instance/<int:pk>/', InstanceDetails.as_view(), name='api_instance_details'),
    path('instance/<int:instance_id>/operation/', InstanceOperationList.as_view(),
         name='api_instance_operation_list'),
    path('instance/<int:instance_id>/operation/<int:operation_id>/request/', OperationRequestCreate.as_view(),
         name='api_operation_request_create'),
    path('request/', RequestList.as_view(), name='api_request_list'),
    path('request/<int:pk>/', RequestDetails.as_view(), name='api_request_details'),
    path('service/', ServiceListCreate.as_view(), name='api_service_list_create'),
    path('service/<int:pk>/', ServiceDetails.as_view(), name='api_service_details'),
    path('service/<int:service_id>/operation/', OperationListCreate.as_view(), name='api_operation_list_create'),
    path('service/<int:service_id>/operation/<int:pk>/', OperationDetails.as_view(), name='api_operation_details'),
    path('service/<int:pk>/request/', ServiceRequestCreate.as_view(), name='api_service_request_create'),
    path('tower/', TowerServerList.as_view(), name='api_tower_server_list_create'),
    path('tower/<int:pk>/', TowerServerDetails.as_view(), name='api_tower_server_details'),
    path('tower/<int:tower_server_id>/job_template/', JobTemplateList.as_view(),
         name='api_job_template_list'),
    path('tower/<int:tower_server_id>/job_template/sync/', JobTemplateSync.as_view(),
         name='api_job_template_sync_all'),
    path('tower/<int:tower_server_id>/job_template/<int:pk>/', JobTemplateDetails.as_view(),
         name='api_job_template_details'),
    path('tower/<int:tower_server_id>/job_template/<int:job_template_id>/sync/', JobTemplateSync.as_view(),
         name='api_job_template_sync'),
]
